#include <io.h>
#include <stdio.h>
#include <string.h>
#include <process.h>
#include <ctype.h>

#define INCL_DOSDATETIME     /* Timer support    */
#define INCL_DOSSEMAPHORES   /* Semaphore values */
#define INCL_DOSERRORS       /* error codes      */
#define INCL_DOSPROCESS
#include <os2.h>

static char *Id = "$Id: ftail.c 1.2 1996/05/12 01:45:59 dz Rel $";

/**
 * 
 * Usage: type \pipe\brake.pipe | ftail
 *
 * $Log: ftail.c $
 * Revision 1.2  1996/05/12 01:45:59  dz
 * Work
 *
 * Revision 1.1  1996/05/11 12:07:39  dz
 * Initial revision
 *
 * 
 * 
 * 
 * 
**/

/**
 * TODO: ...
**/

const max_time = 170;

void wait_sema();
void close_sema();
void create_sema();


void set_color( int time );
void gotoxy( int, int y );

class color
    {
    public:
        enum cname
            {
            lightgray,    cyan,
            magenta,      blue,
            brown,        green,
            red,          black,
            white,        lightcyan,
            lightmagenta, lightblue,
            yellow,       lightgreen,
            lightred,     darkgray
            };
        
        typedef int cid;
        
    protected:
        static const char *color_from_number[16];
        static const cname cname_from_cid[6];
        
        cid id;
    public:
        color( cid c ) { id = c; }
        color() { id = (cid)0; }
        reset() { id = (cid)0; }
        color next() { return (1+id); }
        color prev() { return (id-1); }
        
        void set( void )
            { 
            fprintf( stdout, "\x1b[0;%sm", 
                    color_from_number[cname_from_cid[id]] );
            }
        
        static cid cid_from_time( int time )
            {
            //  ࠧ  饬 
            if( time <  10 ) return 0;
            if( time <  20 ) return 1;
            if( time <  40 ) return 2;
            if( time <  80 ) return 3;
            if( time < 160 ) return 4;
            return 5;
            }
        
        int operator == ( color c ) { return id == c.id; }
        int operator >= ( color c ) { return id >= c.id; }
        int operator <  ( color c ) { return id <  c.id; }
        int operator >  ( color c ) { return id >  c.id; }
        
        operator int() { return (int) id; }
        
    };

const color::cname color::cname_from_cid[] =
//    { yellow, lightred, lightmagenta, lightblue, cyan, darkgray };
    { white, yellow, lightred, lightmagenta, brown, darkgray };

const char *color::color_from_number[] =
    {
    "37",   "36",   "35",   "34",   "33",   "32",   "31",   "30",
    "37;1", "36;1", "35;1", "34;1", "33;1", "32;1", "31;1", "30;1"
    };
        







class tail
    {
    
    
    class line
        {
        protected:
            char        text[81];
            int         time; // since line was placed here
            int         y;
            int         touched;
            color       current_color;
            color       recommended_color;
        public:
            line() 
                {
                time = 0;
                y = 0;
                touched = 1;
                current_color = 0;
                recommended_color = 0;
                }
            
            void set_y( int i ) { y = i; };
            
            void touch() { touched = 1; }
            
            void draw( void )
                { 
                if( !touched ) return;
                current_color.set();
                gotoxy( 0, y );
#if 1
                fprintf( stdout, "%-79.79s", text );
#else
                fprintf( stdout, "%d %d %-50.50s", 
                        (int)recommended_color,
                        (int)current_color,
                        text );
#endif
                touched = 0;
                }
            
            void tick() 
                { 
                if( time <= max_time ) 
                    { 
                    time++; 
                    recommended_color = color::cid_from_time(time);
                    } 
                }
            
            /* arg - color of line above. */
            /* returns 1 if color changed */
            int repaint( color prev_line )
                {
                color our_recommended_color = recommended_color;
                // । ᫨ 梥⮢
#if 0
                if( our_recommended_color == prev_line )
                    return 0;
#else
                if( our_recommended_color >= prev_line )
                    {
                    if( our_recommended_color <= 0 )
                        return 0;
                    our_recommended_color = our_recommended_color.prev();
//                    if( our_recommended_color >= prev_line )
//                        return 0;
                    }
#endif
                if( our_recommended_color <= current_color )
                    return 0;
                
//                if( our_recommended_color == color(-1) )
//                    return 0;
                
                current_color = our_recommended_color;
                touch();
                return 1;
                }
            
            color get_current_color() { return current_color; }
            int get_time() { return time; }
            
            void set( const char *_text ) 
                { 
                strncpy( text, _text, 80); 
                text[78]='\0';
                time = 0; 
                current_color = color::cid_from_time(time);
                touch(); 
                }
            
            const char *get() { return text; }
            
            void scroll( line &l )
                {
                strncpy( text, l.text, 80);
                //text[78]='\0';
                time = l.time;
                current_color = l.current_color;
                recommended_color = l.recommended_color;
                touch();
                }
        };
    
    
    int     window;
    line   *lines;
    
    
public:
    tail( int _window )
        {
        window = _window;
        lines = new line [window];
        for( int i = 0; i < window; i++ )
            lines[i].set_y( i );
        }
    ~tail()
        {
        delete lines;
        }
    
    draw()
        {
        for( int i = 0; i < window; i++ )
            lines[i].draw();
        }
    add( const char *str )
        {
        // 祭  ப ஫  -  ⮪!
        if( lines[0].get_time() < 20 ) DosSleep( 500 );
        
        for( int i = 0; i < window-1; i++ )
            lines[i].scroll( lines[i+1] );
        lines[window-1].set( str );
        //draw();
        }
    
    tick()
        {
        for( int i = 0; i < window; i++ )
            lines[i].tick();
        
        color new_color = 8;
        for( i = 0; i < window; i++ )
            {
            if( lines[i].repaint( new_color ) )
                new_color = lines[i].get_current_color();
            }
        
        }
    
    };



tail   t(20);
HEV     disp_sema;

    
extern "OPTLINK" void ticker(void *val)
    {
    while(1)
        {
        //gotoxy( 0, 23 );
        //fprintf( stdout, "O" );
        t.tick();
        DosPostEventSem( disp_sema );

        //gotoxy( 0, 23 );
        //fprintf( stdout, "o" );
        //fflush( stdout );

        DosSleep( 1000 );
        }
    }


extern "OPTLINK" void shower(void *val)
    {
    char marker = 'a'-1;
    while(1)
        {
        marker++;
        if( marker > 'z' ) marker = 'a';
        
        gotoxy( 0, 23 );
        fprintf( stdout, "%c", toupper( marker ) );
        t.draw();
        gotoxy( 0, 23 );
        fprintf( stdout, "%c", tolower( marker ) );
        fflush( stdout );

        wait_sema();
        }
    }



int main( int ac, char **av )
    {
    
    for( int i = 0; i < 3; i++ )
        puts("\n\n\n\n\n\n\n\n\n");
    
    create_sema();
    
    _beginthread( ticker, 0, 16*1024, 0 );
    _beginthread( shower, 0, 16*1024, 0 );
    
    while(1)
        {
        char str[100];
        if( fgets( str, 79, stdin ) == NULL )
            break;
        char *c = strpbrk( str, "\r\n" );
        if( c ) *c = 0;
        t.add( str );
        DosPostEventSem( disp_sema );
        
        }
    
    close_sema();
    
    
    return 0;
    }





void gotoxy( int x, int y )
    {
    fprintf( stdout, "\x1b[%d;%dH", y+1, x+1 );
    }




void create_sema()
    {
    APIRET  rc            = NO_ERROR;            /* Return code               */
 
    rc = DosCreateEventSem( NULL,
                           &disp_sema,
                           0 /* DC_SEM_SHARED */,
                           FALSE);         /* Semaphore is in RESET state  */
    if (rc != NO_ERROR)
        {
        printf("DosCreateEventSem error: return code = %u\n", rc);
        exit( 1 );
        }
 
    }

void close_sema()
    {
    APIRET rc = DosCloseEventSem(disp_sema);      /* Get rid of semaphore       */
    if (rc != NO_ERROR) 
        printf("DosCloseEventSem error: return code = %u", rc);
    }
 

void wait_sema( void )
    {

    APIRET  rc;         /* Return code                    */
 
    rc = DosWaitEventSem( disp_sema, SEM_INDEFINITE_WAIT );
 
    if (rc != 0) 
        {
        printf("DosWaitEventSem error: return code = %ld", rc);
        return;
        }
    
    ULONG res;
    DosResetEventSem( disp_sema, &res );
    }





